ghc-7.10.3: The GHC API

Safe Haskell | None
Language | Haskell2010

RegAlloc.Linear.StackMap

Description

The assignment of virtual registers to stack slots

Synopsis

- type StackSlot = Int
- data StackMap = StackMap {
  - stackMapNextFreeSlot :: !Int
  - stackMapAssignment :: UniqFM StackSlot
  }
- emptyStackMap :: DynFlags -> StackMap
- getStackSlotFor :: StackMap -> Unique -> (StackMap, Int)
- getStackUse :: StackMap -> Int

# Documentation

type StackSlot = Int

Identifier for a stack slot.

data StackMap

Constructors

StackMap |

Fields

stackMapNextFreeSlot :: !Int

  The slots that are still available to be allocated.

stackMapAssignment :: UniqFM StackSlot

  Assignment of vregs to stack slots.

emptyStackMap :: DynFlags -> StackMap

An empty stack map, with all slots available.

getStackSlotFor :: StackMap -> Unique -> (StackMap, Int)

If this vreg unique already has a stack assignment then return the slot number, otherwise allocate a new slot, and update the map.

getStackUse :: StackMap -> Int

Return the number of stack slots that were allocated